program schedwriter;
// Version 2020-11-25 "Very Early Days...Watch for Goblins" 
// License CC BY-SA 2.0, created by Marc Carson
// Blank schedule generator, used in daily planning and journaling.
// Builds a schedule list template starting from the current time.
// Output is in Markdown format.
// 
// BEGIN EXAMPLE OUTPUT 
// ### Just Schedulin' 
//
// - 1:23 p.m. 
// - :45 
// - 2:00 
// - :15 
// - :30 
// - :45 
// - 3:00 
// - :15 
// - :30 
// - :45 
// - 4:00 
// - :15 
// - :30 
// - :45 
// - 5:00 
// - :15 
// - :30 
// - :45 
// - 6:00 
// - :15 
// - :30 
// - :45
// 
// END EXAMPLE OUTPUT
// TODO Make it show the switch from a.m. to p.m. and v/v
// DONE Make it detect the current minute and start from closest 15m.
// DONE 2020-12-01 Straighten out the formatting.
// DONE 2020-12-01: Clean up the leading zeroes on the hours.

uses dos, sysutils;

// From: https://www.freepascal.org/docs-html/rtl/dos/gettime.html
// Given a word _w_, this function returns it as a string.
Function L0(w:word):string;
var
  s : string;
begin
  Str(w,s);
  if w<10 then
   L0:='0'+s
  else
   L0:=s;
end;

// Declare any variables needed.
var
    j,remaining,position:integer;
    Hour,Min,Sec,HSec : word;
    CurrentHourStr, CurrentMinStr, am_pm, next_am_pm:string;
    
// Main program begins.
begin
    write('### Just Schedulin''');
    writeln(sLineBreak);
    
    // Get the current hour.
    GetTime(Hour,Min,Sec,HSec);
    
    // Set starting position to the top of the hour.
    position := 0;
    
    // Output the hours.
    for j:=0 to 5 do
    begin
    
        // Init general value of where we're at on the hourly clock
        position := 0;
        
        // IN PROGRESS
        // Determine if next hour will change the am/pm
        // if (j < 1) and (Hour = 12) then
        // begin
        //     next_am_pm := 'p.m.';
        //     // writeln('Next hour: ', Hour + 1, 'so ', next_am_pm);
        // end
        // else if (j < 1) and (Hour = 24) then
        // begin
        //     next_am_pm := 'a.m.';
        //     // writeln('Next hour: ', Hour + 1, 'so ', next_am_pm);
        // end 
        // else 
        // begin
        //     // writeln('Hour plus one is ', Hour + 1);
        // end; 
        next_am_pm := '';
        
        // Change 24h time output by GetTime to 12h time.
        if (Hour > 12) then 
        begin
            Hour := Hour - 12;
            am_pm := 'p';
        end
        else if (Hour = 12) then
        begin
            am_pm := 'p';
        end
        else 
        begin
            am_pm := 'a';
        end; 
        
        // Assign the time word value to a string
        CurrentHourStr := L0(Hour);
        
        // Remove leading zeroes from hours to show e.g. 6:00 instead of
        // 06:00.
        if (LeftStr(CurrentHourStr,1) = '0') then
        begin
            CurrentHourStr := RightStr(CurrentHourStr,1);
            // Add a leading space
            CurrentHourStr := ' ' + CurrentHourStr;
        end;
        
        // Similar annoyance with Minutes, but in reverse! Add a leading
        // zero to the minute count, if it's a single digit, so that 
        // we end up with 6:03 intead of 6:3.
        CurrentMinStr := L0(Min); // Convert word to str.
        
        if (length(CurrentMinStr) < 2) then 
        begin
            CurrentMinStr := '0' + CurrentMinStr;
        end;
        
        // Reset remaining value counter.
        // This value is used to determine how many sub-hour marks
        // are left as each hour is processed.
        remaining := 0;

        // If j < 1 we are in the first hour, so we customize the 
        // time display.
        if (j < 1) and (Min > 13) and (Min < 21) then
        begin
            // First hour, after :13 start with :15 slot
            writeln('- ', CurrentHourStr, ':', CurrentMinStr, '', am_pm, ' ');
            remaining := 2;
            position := position + 1;
        end
        else if (j < 1) and (Min > 20) and (Min < 40) then
        begin
            // First hour, after minute :20 start list with :30 slot
            writeln('- ', CurrentHourStr, ':', CurrentMinStr, '', am_pm, ' ');
            remaining := 1;
            position := position + 1;
        end
        else if (j < 1) and (Min > 39) and (Min < 51) then
        begin
            // First hour, after minute :39 start list with :45 slot
            writeln('- ', CurrentHourStr, ':', CurrentMinStr, '', am_pm, ' ');
            remaining := 0;
            position := position + 1;
        end
        else if (j < 1) and (Min > 50) then
        begin
            // First hour, if time is after :50...do nothing
            write('');
        end
        else if (j < 1) then
        begin
            // First hour--otherwise...beginning of hour
            writeln('- ', CurrentHourStr, ':', CurrentMinStr, '', am_pm, ' ');
            position := position + 1;
            remaining := 3;
        end
        else 
        begin
            // Not first hour...just write out the hour
            writeln('- ', CurrentHourStr, ':00 ', next_am_pm);
            next_am_pm := '';
            position := position + 1;
            // Set the remaining display.
            remaining := 3;
        end;
        
        case remaining of
            // Not the first hour, so no worries.
            0 : write ('');
            // End of the first hour.
            1 : writeln('-   :45 '); 
            // Middle of the first hour.
            2 : 
            begin
                writeln('-   :30 '); 
                writeln('-   :45 ');
            end;
            else
            // End of the first hour.
            begin
                writeln('-   :15 '); 
                writeln('-   :30 '); 
                writeln('-   :45 ');
            end;
        end;
        
        // Another pass--increment the hour.
        Hour := Hour + 1;
        
    end; // End hours loop.
    
// End of this Pascal program.
end.
